{ PktXCode - decodes with UUENCODE, XXENCODE, BASE64 or BINHEX encoded files
             out of text files, Fido-PKT-/MSG- or ZConnect files

  Copyright (C) 1996-98 Ulrich Mueller, email: ulrich.mueller@bigfoot.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


  This source code is compatible with:
  - Borland Pascal 7.0 (DOS)
  - Virtual Pascal 1.1 (OS/2)


{ Changes:
  v0.6  -  27.05.96 UUDecodierung in Assembler
           27.05.96 MimeDecodierung in Assembler
           28.05.96 BufGetStr in Assembler
           29.05.96 Anzeige der Durchsatzrate
           31.05.96 keine Bercksichtigung des PKT-Attr-Flags mehr
           01.06.96 Logmails fr XP mglich
           03.06.96 Lschen von gleichen Files
                    BufGetStr setzt Zeiger immer auf Zeilenende
                    BBS- und 4DOS-Beschreibungen
                    DBCache auch beim Dekodieren
                    Loglevel einstellbar
                    neue Summary-Statistik
           04.06.96 manuelle Dekodierung von Dateien
                    Listfunktion erstellt Dateiliste
           06.06.96 XXDecodierung
                    verbesserte Sysfile-Erkennung
           07.06.96 lange Dateinamen ?!
                    kleine Bugfixes & Improvments
  v0.7  -  14.06.96 lange Dateinamen unter OS/2 und Windows95
           18.06.96 nun doch Dekodierung bei zu vielen Zeichen
           21.06.96 Fehler in Bufgetstr bei Pufferende behoben
                    Summary-Logfile nun in kb
                    Fehler in UU/XX-Dekodierung bei Bestimmung der ZL behoben
           22.06.96 Fehler bei isdupe und kurzen Dateinamen behoben
           25.06.96 Fehler in Checkname bei langen Erw behoben
                    Fehler bei Suchedateiverbund/DBCache behoben
                    Prfung, ob unter DOS berhaupt LFN mglich
                    erweiterte ExtPathArea-Funktion (Mustersuche)
                    Untersttzung von UU-MultiFile-Splitting
           26.06.96 erkennt mehrere Mime-Files in einer Mail
           27.06.96 Algo-Bug in Suchedateiverbund behoben
  v0.71 -  05.07.96 Bug bei Areaerkennung kleingeschriebener Areanamen
           13.07.96 korrekte Start/End-Markierung bei Base64
                    Erkennung von Startmarkierungen hinter unvollst. Dateien
                    -> Mime ohne Header wird nicht mehr dekodiert
           20.07.96 XXEncode dekodiert "---" nur bei korrekter Lnge von 3
           21.07.96 ForceFileJoining kommt mit mehreren Files pro Msg zurecht
                    FindLastPart liefert bei Part-Suche Zeiger zurck
  v0.8  -  17.08.96 Bug bei GetNextName/ALN=NO behoben
           30.08.96 Bug in CloseMails (AllMsgData>100%) behoben
                    Bug im Aufruf von FindNext-/LastPart behoben
           07.09.96 Auswahl, welche Areas dekodiert werden sollen
                    elegantere Angabe fr ExtractPath
                    autom. Ermittlung der Dateierweiterung
           08.09.96 Part-Nummer auch bei "Test_0", "Test_1", ...
           17.09.96 Korrektur von IsAvailableW95
           20.09.96 OpenSys bei List/Extractmanual
                    Extractmanual: extarct/delete ALL
                    Schalter fr Mime, ohne Start-/Endheader zu dekodieren
                    '---' wird nicht mehr als XXEncode erkannt!
           22.09.96 '-----...' wird nur bei korrekter Lnge als UU/XX erkannt
                    Zeilenangabe bei Fehler in INI-Datei
           26.09.96 Part-Nummer bei "Test_1" nur, wenn vor Ziffer "-" / "_"
                    CRT_OS2 fr schnellere Bildschirmausgabe
  v0.82    27.09.96 neues ZConnect-Format
           28.09.96 OS2: keine Beschrnkung von Areacountern
                    XMS-Puffer fr DBCache
           29.09.96 Bildschirmausgabe in Fenstern (Decode,Extract,DBCompress)
                    Cache beim Schreiben beim DBCompress
                    verbesserte ZConnect-Format Erkennung
                    Schalter, um Datenbank zu testen (fehlende Dateien...)
           01.10.96 Header in Datenbank
                    autom. Testen der Datenbank
           02.10.96 keine Suminfo-Zeile mehr
                    Sprche an bestimmten Tagen (Weihnacht, Neujahr, ...)
           03.10.96 Fehler, wenn bei /R= keine Files vorhanden sind, behoben
                    neue Loglevel-Option, Ausgabe an Fenster angepat
           04.10.96 Listdatabase im Fenster
                    C+Break-Handler auch fr OS/2
                    Cursorausschaltung
                    OS/2-Exe lt sich aus VDM starten
           05.10.96 Puffer fr Logfiles
           06.10.96 schnellere Datenbankkomprimierung durch fDel-Flag
                    Bug in GetNextName behoben, wenn mehr Stellen entsteh.
                    Buf in ShalldecodeArea/Upcase behoben
           08.10.96 DupeHandling-Option
                    ExistFile mit FindFirst realisiert
           10.10.96 DOS+OS/2-Exe verbunden
                    Einschrnkung bei Split-Erkennung ("2. Bild")
  v0.90    12.10.96 BinHexDecodable
           15.10.96 Base64-Endmarker, wenn "=" am Zeilenende gefunden
                    Untersttzung von Textdateien
           19.10.96 neue Part- und Filename-Erkennung
           20.10.96 Bug bei UUdecode behoben, wenn Zeile mit "-" beginnt
                    Binhexdecodierung komplett
           24.10.96 XMS-Datei- und IDX-Pufferung
                    Compressdatabase autom. beim Schlieen der Datenbank
                    Zusatzspeicher auch unter OS2
           25.10.96 Dirtyinfo fr xmIdxCache
                    einstellbare Maximallnge fr Subject
           26.10.96 Fehler in UU-/XX-Lngenvergleich behoben
                    neue ZConnect-Erkennung
           27.10.96 Auto-Funktion fr Speichergre
           30.10.96 Cursortasten bei Listfuntion
                    Anzeige, welcher Kodiertyp verwendet
           01.11.96 Erkennung "Teil_1" reaktiviert
           08.11.96 Bei Programmstart Smartdrv flushen
  v0.91    10.11.96 Fehlerbehebung in LoadINI/LogMailArea
                    Matchsize nur noch bei Mails ohne Split/Part/Head relevant
           15.11.96 GetSplit-/PartNumber gefixed
           17.11.96 Bedingung fr SaveOutIDX verbessert
                    Binhex prft Headergre
           20.11.96 Bug in Value() behoben
           22.11.96 Bug mit Logfiles/SetTextBuf behoben
                    erweitertes UU-Format (ASCII 97..127)
           23.11.96 Error-Abbruch verursacht keinen Datenverlust
                    Verifydatabase fnge gekrzte Datendatei ab
           24.11.96 OS2: statt XMR/W direkter Zugriff auf BaseMemPtr
                    Taskblocking anhand Database
                    Fehlermeldung, wenn Festplatte voll
                    Mime-Erkennung fr Dateiname
           26.11.96 Unterscheidung Decodable / Maybedecodable
                    CriticalSubjLen - Schalter eingefhrt
                    Autofunktion fr Base64Header
           27.11.96 Bug in ExtractManul: View erased entrys, behoben
  v0.91e   28.12.96 ExistPath: neue Methode
           30.12.96 XMS-GetFreeMem bugfix
           01.01.97 Fehler im Umgang mit Suredecodable behoben
           04.01.97 Bug bei ForceFileJoining: keine Ausgaben mehr, behoben
  v1.1     07.01.97 SplitText eingefhrt
                    Reihenfolge bei Decode gendert
           08.01.97 IsDupeAny bei CompareAll vergleicht mit allen Dateien
           12.01.97 verbesserte Unterscheidung von Text und kod. Daten
                    DupeHandling fr ExtPath einstellbar
           13.01.97 Bug in ExtractFile bei Binhexerror behoben
           07.02.97 Fido-FSC-0047 kompatible Split-Erkennung (Betreff egal!)
                    keine CaseSensity bei BASE64-Header
                    PreReaddir untersttzt lange Dateinamen
           09.02.97 Schalter UseLongNames=Force
           15.02.97 Extpath anhand Dateierweiterung
           16.02.97 Bezge im DB-Index werden nach Komprimierung restautiert
                    Verzeichnisse, die nicht existieren, werden autom. erstellt
           18.02.97 neue, stark verbesserte File-Cache-Funktion
           20.02.97 zu dekodierende Files werden in Liste aufgenommen
           22.02.97 kodierte Daten werden aus DestFile entfernt
           26.02.97 VP: ebx sichern !
  v1.11    06.03.97 bei UUorXX-Start wurde nField nicht initalisiert
  v1.12    12.03.97 Bug beim Linken Nachrichten mit UU-/FCS-Splitmarkierung beh.
  v1.13    09.04.97 bei UUorXX-Start wurde CloseOutField nicht aufgerufen
  v1.15    27.06.97 fehlerhafte Fido-FSC-Implementation wird untersttzt
           09.07.97 lange Dateinamen werden berprft
                    Schalter /X verhindert, da neue Dateien erstellt werden
                    BP 7.0-Bug auf schnellen Prozessoren (PII200+) behoben
                    Batchdatei heit unter DOS+OS/2 immer PKTXREN.CMD
                    neues Datenbank-Format
                    neuer INI-Schalter: BinkleyFilter=NO
           10.07.97 bei gelinkten Nachrichten wird bei allen neuestes Datum ges.
           11.07.97 Untersttzung des Binkley-Outbounds
           30.07.97 CreateDescStyle eingefhrt
                    PGP signierte Nachrichten werden nicht mehr ignoriert
           25.08.97 FileTime eingefhrt
           29.08.97 Parameter mit Leerzeichen werden untersttzt ("x y")
           26.09.97 Ende eines PGP-Blocks wird korrekt erkannt
           13.01.98 SplitText: "^[" bzw. "^]" stehen fr echte Klammern
                    Korrektur der Base64-Dekodierung
                    Korrektur der Speichergre unter Win95
  v1.16    25.02.98 Fehler bei BinHex-Kodierung behoben
                    UU/XX-Formate mit zustzlichem Prfzeichen wird ntersttzt
  v1.17    08.03.98 Aufhnger bei ZipMagic behoben, 'ZipMagic95Compatibility'
  v1.20    18.03.98 Vollendung des Netmailfilters
           05.04.98 MSG gemaess FTS-0001 :-)
           06.04.98 Namensgebung der MSG/PKT gendert
           09.04.98 Schalter /E
           10.04.98 Fido: kompatibel mit $1A Fileende
                    Fehler bei BinHex/CRC-Prfung unter OS/2 behoben
           17.04.98 SwapLongint/2 korrigiert
                    alternative CRC-Prfung, BAD-Flag bei FileExtract
           08.05.98 wieder Freeware
  v1.21    26.05.98 File-Attach: jetzt mit Pfadangabe
                    Rechenzeitreigabe bei Taskblocking/R-Blocking
                    Fix: crash, wenn temp. Pufferdatei nicht erstellt w.kann
  v1.21+   27.05.98 kein Case-Sensity von attachmessage
                    Delay/2: Idle
           23.06.98 DetectPktType: ZConnect erkennt KOP-Header
  v1.30    05.11.98 CloseMail: MayDelete prueft Mindestgroesse jetzt richtig


Bekannte Bugs:
- PktXCode erwartet, dass PKT/MSG-Dateien mit einem #0 enden. Die original
  Fidosoft benutzt dazu die Zeichenfolge #13#10#13#10
  Auswirkung: wenn PktXCode die Dateien modifiziert, ist das Paketende evtl.
  nicht mehr spezifikationsgemaess.

}

{$M 32768, 0, 655360}

{ Maximal bentigter Speicher auf dem Heap:
 screen: 4000
 initdb: outfield - 16384+4096
         idxcache - 16384
 inifile: decodearea  -   86 * 100 =  8800
          modifyarea  -   87 * 100 =  8800
          extractpath -  348 * 100 = 34800

 decode:  destfield - 16384 + 4096
          infield   - 16384 + 4096
          dec_buf   -  4*x    16480
          decodefield - 65464
 xmem : 16384 xbuf
          144 fileinfo
        16386 binfo
                           -> 249082

 a) preread/checkdir: filelist - 65260
    dekodieren: infield - 32768+4096   -> 177756
 b) extractfile: bufinload   - 8192
                 bufbitshift - 8192
 c) compress: idxbuf - 32768
}

{$I SETTINGS.INI}

Program PKTXCODE;

{$IFDEF OS2}
{$LINKER
NAME PktXCode
STUB "C:\BP\EXE\PKTXCODE.EXE"
}

Uses CRT_OS2,
{$ELSE}
Uses CRT,
{$ENDIF}
     DOS,
     Strings,
     PKTX_IO,
     PKTX_KEY,
     PKTX_SCR,
     PKTX_DB,
     PKTX_APP,
     PKTX_MEM,
     PKTX_LNK,
     PKTX_DEC,
     PKTX_LFN
 {$IFDEF Binkley}
   , PKTX_BNK
 {$ENDIF};

CONST HeapRequired = 249082;

{***************************************************************************}
{ Bearbeitung von Nachrichten }
{***************************************************************************}

PROCEDURE InitMail;
{ DB-Kopf fr neue Mail vorbereiten / Subj auswerten }
{ immer aufrufen, wenn evtl. neue Datei kommt }
{ Split: wenn direkt am Anfang des Betreffs eine Nummer steht, dann ist
         das IMMER die Splt-Nummer }

  PROCEDURE GetFileName;
  CONST MaxFileName = 32;
  VAR i, l, r: Byte;
  BEGIN
    OutIDX.rFileName.Name:='';
    If OutIDX.SubjStr='' Then OutIDX.SubjStr:='(no subject)'
    Else Begin
      i:=Length(OutIDX.SubjStr);
      While (i>1) And (OutIDX.rFileName.Name='') Do Begin
        While (i>1) And (OutIDX.SubjStr[i]<>'.') Do
          Dec(i);
        If i>1 Then Begin
          l:=i;
          While (l>1) And (l+MaxFileName>i) And (Doschar(Upcase(OutIDX.SubjStr[l-1]))) Do
            Dec(l);

          r:=i;
          While (r<Length(OutIDX.SubjStr)) And (r<i+3)
            And (Doschar(Upcase(OutIDX.SubjStr[r+1]))) Do
            Inc(r);

          If (l<>i) And (r<>i) Then
            OutIDX.rFileName.Name:=Copy(OutIDX.SubjStr, l, r-l+1);
          Dec(i);
        End;
      End;
    End;
    If OutIDX.rFileName.Name='' Then OutIDX.rFileName.Name:=OutIDX.SubjStr;

    OutIDX.rFileName.Long:=True;
  END;

  PROCEDURE GetSplitNumber;
  VAR ps, pt : Byte;

    PROCEDURE GetText;
    VAR psOld  : Byte;
        Error  : Boolean; { Fehler beim vergl. aufgetreten }

      PROCEDURE GetValue(Var w: Word);
      VAR i: Byte;
      BEGIN
        Inc(pt);

        i:=ps;
        While (ps<=Length(OutIDX.PartStr)) And (OutIDX.PartStr[ps] In ['0'..'9']) Do
          Inc(ps);

        If ps=i Then Error:=True
        Else w:=Value(Copy(OutIDX.PartStr, i, ps-i));
      END;

    BEGIN
      psOld:=ps;
      Error:=False;

      While (Not Error) And (pt<=Length(SplitText)) And (ps<=Length(OutIDX.PartStr)) Do Begin
        If (SplitText[pt]='^') And (SplitText[pt+1] In ['[', ']'])
           And (pt<Length(SplitText)) Then Inc(pt);

        If SplitText[pt]='x' Then GetValue(OutIDX.cSplit)
        Else If SplitText[pt]='y' Then GetValue(OutIDX.cSplitOf)
        Else If (SplitText[pt]=']') And (SplitText[pt-1]<>'^') Then Begin
          Inc(pt);
          Error:=True;
        End Else If (SplitText[pt]='[') And (SplitText[pt-1]<>'^') Then Begin
          Inc(pt);
          GetText;
        End Else Begin
          If OutIDX.PartStr[ps]=SplitText[pt] Then Begin
            Inc(ps);
            Inc(pt);
          End Else Begin
            Error:=True;
            ps:=psOld;

            While (pt<=Length(SplitText)) And
             ((SplitText[pt]<>']') Or (SplitText[pt-1]='^')) Do
              Inc(pt);

            If (pt<=Length(SplitText)) And (SplitText[pt]=']')
                                       And (SplitText[pt-1]<>'^')
             Then Inc(pt);
          End;
        End;
      End;
    END;

  BEGIN
    { Split-Nummer: 1Test, 1:Test, 1: Test, 1/2: Test ... }
    {               aber nicht: 1. Test, 1 Test, 1% }
    OutIDX.cSplit:=1;
    OutIDX.cSplitOf:=isUnassigned;

    pt:=1; { Position in SplitText }
    ps:=1; { Position in Subj }
    GetText;

    If ps=1 Then Begin
      OutIDX.cSplit:=1;
      OutIDX.cSplitOf:=isUnassigned;
    End Else Delete(OutIDX.PartStr, 1, ps-1);
  END;

  PROCEDURE GetPartNumber;
  VAR a1, a2, b1, b2, i, Start : Byte;
      Gap                      : String[4];
  BEGIN
    OutIDX.cPart:=isUnassigned;
    OutIDX.cPartOf:=isUnassigned;

    { Part-Nummer holen }
    Start:=Length(OutIDX.PartStr);
    If Start>CriticalSubjLen Then Start:=CriticalSubjLen;

    While Start>1 Do Begin
      b2:=Start;
      While (b2>=1) And (Not (OutIDX.PartStr[b2] In ['0'..'9'])) Do
        Dec(b2);

      { Ziffer gefunden }
      b1:=b2;
      While (b1>1) And (OutIDX.PartStr[b1-1] In ['0'..'9']) Do
        Dec(b1);

      Start:=b1;
      If Start>0 Then Dec(Start); { vor Ziffer }

      { Wenn rechter Rand ... }
      If ( (b2>0) And ((b2=Length(OutIDX.PartStr))
       Or (Pos(OutIDX.PartStr[b2+1], ' ])')<>0)) ) And
      { und linker Rand gltig... }
       ( (b1=1) Or (Pos(OutIDX.PartStr[b1-1],' /')<>0) ) Then Begin
        i:=b2-b1+1;
        OutIDX.cPartOf:=Value(Copy(OutIDX.PartStr,b1,b2-b1+1));
        i:=b2;
        { dann ist diese Zahl "PartOf" }

        { existiert eine Zahl davor? (x/y, x of y, x von y)}
        a2:=b1-1;
        While (a2>=1) And (Not (OutIDX.PartStr[a2] In ['0'..'9'])) Do
          Dec(a2);

        If a2<>0 Then Begin
          a1:=a2;
          While (a1>1) And (OutIDX.PartStr[a1-1] In ['0'..'9']) Do
            Dec(a1);

          { a1-a2 zeigt auf eine Zahl }
          b2:=b1-1;
          b1:=a2+1;

          { b1-b2 zeigt auf Zwischenraum }
          While (b1<=Length(OutIDX.PartStr)) And (OutIDX.PartStr[b1]=' ') Do
            Inc(b1);
          While (b2>1) And (OutIDX.PartStr[b2]=' ') Do
            Dec(b2);

          Gap:=UpcaseStr(Copy(OutIDX.PartStr,b1,b2-b1+1));
          { ist Zwischenraum korrekt und linker Rand ok ? }
          If ((Gap='/') Or (Gap='OF') Or (Gap='VON')) And
             ((a1=1) Or (Pos(OutIDX.PartStr[a1-1],' [(')<>0)) Then Begin

            OutIDX.cPart:=Value(Copy(OutIDX.PartStr,a1,a2-a1+1));
            If a1>1 Then Dec(a1);
            Delete(OutIDX.PartStr,a1,i-a1+2);

            Insert('[x/x]', OutIDX.PartStr, a1);
            Start:=0;
          End;
        End;

        If OutIDX.cPart=isUnassigned Then OutIDX.cPartOf:=isUnassigned;
      End;
    End;

    { test_x suchen }
    If OutIDX.cPartOf=isUnassigned Then Begin
      OutIDX.cPart:=isUnassigned;

      Start:=Length(OutIDX.PartStr);
      If Start>CriticalSubjLen Then Start:=CriticalSubjLen;

      While Start>1 Do Begin
        b2:=Start;
        While (b2>=1) And (Not (OutIDX.PartStr[b2] In ['0'..'9'])) Do
          Dec(b2);

        { Ziffer gefunden }
        b1:=b2;
        While (b1>1) And (OutIDX.PartStr[b1-1] In ['0'..'9']) Do
          Dec(b1);

        Start:=b1;
        If Start>0 Then Dec(Start); { vor Ziffer }

        { Wenn rechter Rand ... }
        If ( (b2>0) And ((b2=Length(OutIDX.PartStr))
         Or (Pos(OutIDX.PartStr[b2+1], ' ])-_')<>0)) ) And
        { und linker Rand gltig... }
         ( (b1=1) Or (Pos(OutIDX.PartStr[b1-1],' [(-_')<>0) ) Then Begin
          i:=b2-b1+1;
          OutIDX.cPart:=Value(Copy(OutIDX.PartStr,b1,i));
          Delete(OutIDX.PartStr, b1, i);
          Insert('x', OutIDX.PartStr, b1);
          Start:=0;
        End;
      End;
    End;
  END;

BEGIN
  deInit;

  ThisMsgData:=False;
  ThisMsgModify:=ShallModifyArea(OutIDX.AreaStr, PKTType);
  ThisMsgIsModified:=False;
  ThisMsgBodyStart:=FDestFilePos+DestPos;

  GetDateDT(OutIDX.Date);
  GetFileName;
  GetSplitNumber;
  GetPartNumber;
END;

PROCEDURE CloseMail;
{ Datei schlieen, Zhler setzen }
BEGIN
  deClose;

  If ThisMsgData And
     ((ThisMsgModify=mmDelete) Or
      ((ThisMsgModify=mmMayDelete) And
      ( (FDestFilePos+DestPos)-ThisMsgBodyStart<256) And
      (((OutIDX.cSplit>1) And (OutIDX.cSplit<>isUnassigned)) Or
       ((OutIDX.cPart >1) And (OutIDX.cPart <>isUnassigned))) )) Then Begin

    xMemTruncFile(FDest, ThisMsgHeadStart, DestField^, DestPos);
    FDestFilePos:=xMemFilePos(FDest);
    FDestMemPos:=FDestFilePos+DestPos;

    Inc(stAllFMsgDeleted);
    ThisMsgIsModified:=False; { nicht zustzlich krzen ! }
  End;

  If ThisMsgData Then Begin
    ThisMsgData:=False;
    Inc(stFileMsgData);
    Inc(stAllFMsgData);
  End;

  If ThisMsgIsModified Then Inc(stAllFMsgShortened);
END;

{***************************************************************************}
{ Typerkennugn und Dekodierung }
{***************************************************************************}

PROCEDURE DecodePKT(FPos: Word);
{ Eintrag "FPos" aus DecodeList dekodieren }
CONST feNo       =   0;
      feMsg      =   1;
      feFile     =   2;
      MaxLen     = 255;
{$IFDEF German}
      StrTextfile = '(Textdatei)';
      TxtDenied1  = 'Zugriff auf ';
      TxtDenied2  = ' verweigert!';
      TxtTmpCrt   = 'Fehler beim Erstellen der temporren Pufferdatei ';
      TxtTmpWrt   = 'Fehler beim Schreiben in temporre Pufferdatei';
      TxtTmpRen   = 'Fehler beim Umbenennen der temporren Pufferdatei';
{$ELSE}
      StrTextfile = '(text file)';
      TxtDenied1  = 'access to ';
      TxtDenied2  = ' denied!';
      TxtTmpCrt   = 'error creating temporary buffer file ';
      TxtTmpWrt   = 'error writing to temporary buffer file';
      TxtTmpRen   = 'error renaming temporary buffer file';
{$ENDIF}
VAR Got                      : {$IFDEF OS2} LongInt {$ELSE} Word {$ENDIF};
    LenC                     : LongInt;

{***************************************************************************}

    PROCEDURE LoadInfield;
    VAR Got: {$IFDEF OS2} LongInt {$ELSE} Word {$ENDIF};
    BEGIN
      If Not InfieldReadAll Then Begin
        Move(InField^[InPos], InField^, InSize-InPos);
        Dec(InSize, InPos);

        Inpos:=((FieldSize-Insize) Div 4096)*4096;

        BlockRead(FSource, InField^[InSize], InPos, Got);
        GetError;

        Inc(Insize, Got);
        Inc(stFilePrcd, Got);
        Inc(stAllFPrcd, Got);

        If Got<>InPos Then InfieldReadAll:=True;
        InPos:=0;
        UpdateDecodeScreen;
      End;
    END;

{***************************************************************************}

    PROCEDURE SaveDestfield; Near;
    BEGIN
      If FDestError Then DestPos:=0
      Else Begin
        xMemAppendFile(FDest, DestField^);
        GetError;
        If Result<>0 Then FDestError:=True;

        Inc(FDestFilePos, BlockSize);

        Dec(DestPos, BlockSize);
        If DestPos>0 Then Move(DestField^[BlockSize], DestField^, DestPos);
      End;
    END;

{***************************************************************************}

    CONST bfgInit      = 0; { kein Nachladen von Disk }
          bfgText      = 1;
          bfgPKTHeader = 2; { #0 ist Zeilenende }
          bfgPKTLine   = 3; { #0 ist Mailende }
{! EOF-Markierung 1Ah beachten }
    PROCEDURE BufGetStr(Typ: Byte);
    VAR Done     : Word;
        PktDone  : Boolean;
        LineDone : Byte;
    BEGIN
      OutString:='';
      LineDone:=1; { Zhler, wiewiele Durchlufe noch ntig sind;
                     wenn eine Zeile >255 Zeichen am Datenende liegt,
                     dann mu diese erst noch zuende und dann die nchste
                     gelesen werden }
      Repeat
        If LineDone=1 Then FDestMemPos:=FDestFilePos+DestPos;
        If (Typ<>bfgInit) And (InPos+InPreload>=InSize) Then LoadInfield;

{ Zeile aus Infield in DestField kopieren }
        Asm
{$IFDEF OS2} push   esi                   {$ELSE} push ds                    {$ENDIF}
{$IFDEF OS2} push   edi                   {$ELSE}                            {$ENDIF}
{$IFDEF OS2} push   ebx                   {$ELSE}                            {$ENDIF}

             mov PktDone, 0

             { Nachladen? }
{$IFDEF OS2} movzx eax, inpos             {$ELSE} mov ax, inpos              {$ENDIF}
             mov cx, insize
             sub cx, ax     { cx:restspeicher in infield, wird gleich bentigt}
             jb @is_fileend

             cmp infieldreadall, 1
             jne @Weiter_FileEnd

             inc cx         {letztes zeichen darf hier gelesen werden}

           @Weiter_FileEnd:
             mov dl, fdestopen
             { Modifymodus ? }
             or  dl, dl
             jnz @MailModify

{$IFDEF OS2} xor ebx, ebx                 {$ELSE} xor bx, bx                 {$ENDIF}

             mov destpos, bx
             jmp @Modify_NotModify

           @MailModify:
{$IFDEF OS2} movzx ebx, destpos           {$ELSE} mov bx, destpos            {$ENDIF}

           @Modify_NotModify:
{$IFDEF OS2} mov edi, destfield           {$ELSE} les di, destfield          {$ENDIF}
{$IFDEF OS2} add edi, ebx                 {$ELSE} add di, bx                 {$ENDIF}
{$IFDEF OS2}                              {$ELSE}                            {$ENDIF}
{$IFDEF OS2} mov esi, infield             {$ELSE} lds si, infield            {$ENDIF}
{$IFDEF OS2} add esi, eax                 {$ELSE} add si, ax                 {$ENDIF}

             { maximalen Speicherplatz feststellen }
             mov ax, fieldsize
             sub ax, bx { ax: restspeicher in destfield }

             cmp cx, ax
             jb @1
             mov cx, ax

           @1:
             dec cx     { weil bei CR+LF zwei Zeichen auf einmal gelesen werden }
             mov bx, cx { -> cx: maximaler freier Speicher }
             xor dx, dx { Zhler fr nicht-Outstring-Zeichen }

             cld
             cmp Typ, bfgPKTHeader
             jae @PKT_schleife_start

           @TXT_schleife_start:
             lodsb
             stosb

             cmp al, 13
             je @zeilenende_13
             cmp al, 10
             je @zeilenende_10

             dec cx
             jnz @TXT_schleife_start

             mov LineDone, 2
             jmp @zeilenende2

           @PKT_schleife_start:
             lodsb
             stosb

             cmp al, 13
             je @zeilenende_13
             cmp al, $1A
             je @abschnittsende
             or  al, al
             jz @abschnittsende

             dec cx
             jnz @PKT_schleife_start

             mov LineDone, 2
             jmp @zeilenende2

           @zeilenende_13:
             inc dx

             lodsb
             cmp al, 10
             je @lf
{$IFDEF OS2} dec esi                      {$ELSE} dec si                     {$ENDIF}
             jmp @zeilenende

            @lf:
             stosb
             dec cx
           @zeilenende_10:
             inc dx
             jmp @zeilenende

           @abschnittsende:
             inc dx
             cmp Typ, bfgPKTLine
             jne @zeilenende
             mov PktDone, 1

           @zeilenende:
             dec LineDone
             dec cx { incl letztes zeichen! }

           @zeilenende2:
             sub bx, cx { -> bx: gelesene Zeichen }

             cmp LineDone, 0
             jne @kein_outstring
             cmp bx, 255
             ja  @kein_outstring

           { Kopieren }
{$IFDEF OS2}                              {$ELSE} mov ax, seg inpos          {$ENDIF}
{$IFDEF OS2}                              {$ELSE} mov ds, ax                 {$ENDIF}
{$IFDEF OS2}                              {$ELSE} mov ax, inpos              {$ENDIF}
{$IFDEF OS2}                              {$ELSE}                            {$ENDIF}
{$IFDEF OS2} mov esi, infield             {$ELSE} lds si, infield            {$ENDIF}
{$IFDEF OS2} movzx eax, inpos             {$ELSE} add si, ax                 {$ENDIF}
{$IFDEF OS2} add esi, eax                 {$ELSE}                            {$ENDIF}
{$IFDEF OS2}                              {$ELSE} mov ax, seg outstring      {$ENDIF}
{$IFDEF OS2} mov edi, offset outstring    {$ELSE} mov es, ax                 {$ENDIF}
{$IFDEF OS2} xor ecx, ecx                 {$ELSE} mov di, offset outstring   {$ENDIF}

             mov ax, bx
             sub ax, dx
             mov cx, ax

             stosb

             mov cx, bx
             rep movsb

           @kein_outstring:
{$IFDEF OS2}                              {$ELSE} mov ax, seg infield        {$ENDIF}
{$IFDEF OS2}                              {$ELSE} mov ds, ax                 {$ENDIF}
             add destpos, bx
             add inpos, bx
             mov Done, bx

             { ende ? }
             mov al, infieldreadall
             or  al, al
             jz @kein_readall

             mov ax, inpos
             mov bx, insize
             cmp ax, bx
             jne @kein_readall

           @is_fileend:
             mov al, feFile
             mov infileend, al

             jmp @exit

           @kein_readall:
             cmp pktdone, 1
             jne @exit

             mov al, feMsg
             mov infileend, al

           @exit:
{$IFDEF OS2} pop    ebx                   {$ELSE}                            {$ENDIF}
{$IFDEF OS2} pop    edi                   {$ELSE}                            {$ENDIF}
{$IFDEF OS2} pop    esi                   {$ELSE} pop  ds                    {$ENDIF}
        End;

        Dec(LenC, Done);
        If (Typ<>bfgInit) And (FDestOpen) And (DestPos>=BlockSize)
          Then SaveDestField;

      Until (LineDone=0) Or (InFileEnd<>feNo) Or (Typ=bfgInit);
    END;

{***************************************************************************}

  PROCEDURE DetectPKTType;
  TYPE Buf5                    = Array[1..4] Of Char;
  VAR Found1, Lines            : Byte;
      cmp                      : String[3];
      pZ                       : ^Buf5;
      pP                       : ^tPKTHdr;
      pM                       : ^tMSGHead absolute pP;
  BEGIN
      PKTType:=ptUnknown;

      Inpos:=0;
      DestPos:=0;
      InFileEnd:=feNo;

      pZ:=@OutString[1];
      Lines:=15;
      Found1:=0;

      While (Lines>0) And (Found1<3) And (InFileEnd=feNo)
       And (InPos+InPreload<=InSize) Do Begin
        BufGetStr(bfgInit);

        If Length(OutString)>=4 Then
          If (pZ^='ABS:') Or (pZ^='BET:') Or (pZ^='EDA:') Or (pZ^='EMP:') Or
             (pZ^='LEN:') Or (pZ^='MID:') Or (pZ^='ROT:') Or (pZ^='KOP:')
               Then Inc(Found1);

        Dec(Lines);
      End;

      If Found1=3 Then PKTType:=ptZconnect
      Else Begin
        pP:=@InField^;
        If (Got>SizeOf(TPktHdr)) And (pP^.Ver=$0002) Then PKTType:=ptPKT
        Else Begin
          Lines:=0;
          Move(pM^.DateTime[3], cmp[1], 3);
          cmp[0]:=#3;

          Repeat
            Inc(Lines);
          Until (Lines=13) Or (cmp=cMonth[Lines]);

          If Lines<>13 Then PKTType:=ptMSG;
        End;
      End;
  END;

{***************************************************************************}

  PROCEDURE UnpackMSG(Mode: Byte); {MSG oder PKT}
  { Abarbeitung eines MSG-Files }
  CONST klany   : String[1] = #1;
        klToPt  : String[6] = #1'TOPT '; { <pt no> }
        klIntl  : String[6] = #1'INTL '; { <dest z:n/n> <orig z:n/n> }
                                          { Angaben in Header egal ! }
        klMsgID : String[8] = #1'MSGID: '; { ^AMSGID: origaddr serialno }
  VAR DestAddr   : tFidoAddr2; { Fido-Adresse des Senders }
      DoRepeat   : Boolean;
      pm         : ^tPktMsgHdr;
      pmsg       : ^tMsgHead;

    PROCEDURE CheckLine;
    VAR Addr       : tFidoAddr2;
        i          : Byte;
    BEGIN
      If OutStringStart_CaseSensity(klToPt) Then Begin
        DestAddr.Point:=Value(Copy(OutString, Length(klToPt)+1 ,255));
        DestAddr.IsPoint:=True;
      End Else If OutStringStart_CaseSensity(klIntl) Then Begin
        { 2. Leerzeichen suchen }
        i:=Length(klIntl)+1;
        While (i<=Length(OutString)) And (OutString[i]<>' ') Do
          Inc(i);

        If (OutString[i]=' ') And GetFidoAddr(Copy(OutString,
           Length(klIntl)+1, i-(Length(klIntl)+1) ), Addr) Then Begin
          If DestAddr.IsPoint And (Not Addr.IsPoint) Then Begin
            Addr.IsPoint:=True;
            Addr.Point:=DestAddr.Point;
          End;
          DestAddr:=Addr;
        End;
      End Else If OutStringStart_CaseSensity(klMsgID) Then Begin
        { Zone ermitteln }
        If DestAddr.Zone=isUnassigned Then Begin
          i:=Length(klMsgID)+1;
          While (i<=Length(OutString)) And (OutString[i] In ['0'..'9'])
           And (OutString[i]<>':') Do
            Inc(i);

          If (i<=Length(OutString)) And (OutString[i]=':') Then
            DestAddr.Zone:=Value(
             Copy(OutString, Length(klMsgID)+1, i-(Length(klMsgID)+1)));

        End;
      End;
    END;

  BEGIN
    While (InFileEnd<>feFile) And (ErrorAbort=eaOK) And
     ( ( (Mode=ptMSG) And (InSize-InPos>SizeOf(tMsgHead)) ) Or
       ( (Mode=ptPkt) And (InSize-InPos>SizeOf(tPktMsgHdr)) )) Do Begin

      Fillchar(OutIDX, SizeOf(OutIDX), 0);
      ThisMsgHeadStart:=FDestFilePos+DestPos;

      If Mode=ptPkt Then Begin
        Move(Infield^[InPos], DestField^[DestPos], SizeOf(TPktMsgHdr));

        pm:=@Infield^[InPos];
        DestAddr.Zone:=isUnassigned;
        DestAddr.Net :=pm^.DestNet;
        DestAddr.Node:=pm^.DestNode;
        DestAddr.IsPoint:=False;

        Inc(Inpos, SizeOf(TPktMsgHdr));
        Inc(DestPos, SizeOf(TPktMsgHdr));

        InFileEnd:=feNo;

        { Datum, To, From, Subj }
        BufGetStr(bfgPKTHeader);
        BufGetStr(bfgPKTHeader);
        OutIDX.AreaStr:='NETMAIL: '+OutString; { Echomail: wird berschrieben }
        OutIDX.FidoAddr.Name:=OutString;

        BufGetStr(bfgPKTHeader);
        BufGetStr(bfgPKTHeader); {72}
        OutIDX.SubjStr:=OutString;
        OutIDX.PartStr:=OutString;
      End Else Begin
        Move(Infield^[InPos], DestField^[DestPos], SizeOf(TMsgHead));

        pmsg:=@Infield^[InPos];

        DestAddr.Zone   :=pmsg^.DestZone;
        DestAddr.Net    :=pmsg^.DestNet;
        DestAddr.Node   :=pmsg^.DestNode;
        DestAddr.Point  :=pmsg^.DestPoint;
        If DestAddr.Zone=0 Then DestAddr.Zone:=isUnassigned;
        If DestAddr.Point=0 Then DestAddr.IsPoint:=False;

        OutIDX.FidoAddr.Name:=StrPas(pmsg^.toUserName);
        OutIDX.AreaStr:='NETMAIL: '+OutIDX.FidoAddr.Name;
        OutIDX.SubjStr:=StrPas(pmsg^.Subject);
        OutIDX.PartStr:=OutIDX.SubjStr;

        Inc(Inpos, SizeOf(TMsgHead));
        Inc(DestPos, SizeOf(TMsgHead));

        InFileEnd:=feNo;
      End;

      BufGetStr(bfgPKTLine);

      { Area und Kludges auswerten (Point, Zone) }
      If (Copy(OutString, 1, 5) <> 'AREA:') Then Begin { Netmail! }
        InitMail;

        {$IFDEF Debug_BNK}
        BnkLog('initializing Netmail');
        {$ENDIF}

        If OutStringStart_CaseSensity(klAny) Then Begin
          CheckLine;
          DoRepeat:=True;
          While (InFileEnd=feNo) And (ErrorAbort=eaOK) And DoRepeat Do Begin
            BufGetStr(bfgPKTLine);
            If OutStringStart_CaseSensity(klAny) Then CheckLine
            Else DoRepeat:=False;
          End;
        End;

        OutIDX.AreaStr:=OutIDX.AreaStr+'@'+WriteFidoAddr(DestAddr);
        {$IFDEF Binkley}
        OutIDX.FidoAddr.Addr:=DestAddr;
        OutIDX.Inbound:=DecodeList^.FromPath;
        OutIDX.PktType:=PKTType;

        If (BinkleyFilter) And (Not DoRepeat) Then BnkInitMail;
        {$ENDIF}
{debuginfo('### Mail from: '+outidx.fidoaddr.name+'@'
          +WriteFidoAddr(outidx.fidoaddr.addr));}

        {$IFDEF Debug_BNK}
        BnkLog('Subject: '+OutIDX.SubjStr);
        BnkLog('Destination: '+outidx.fidoaddr.name+'@'
          +WriteFidoAddr(outidx.fidoaddr.addr));
        {$ENDIF}

      End Else Begin { Echomail, d.h. Empfnger egal }
        OutIDX.AreaStr:=Copy(OutString, 6, 255);
        OutString:=''; { Zeile nicht dekodieren }
        InitMail;

        {$IFDEF Debug_BNK}
        BnkLog('initializing Echomail');
        BnkLog('Subject: '+OutIDX.SubjStr);
        BnkLog('Area: '+outidx.areastr);
        {$ENDIF}
      End;

      If {$IFDEF Binkley} BnkThisMail Or {$ENDIF}
       ShallDecodeArea(OutIDX.AreaStr) Then Begin

        If Length(OutString)>0 Then deDecode; { Zeile prfen/decodieren }

        While (InFileEnd=feNo) And (ErrorAbort=eaOK) Do Begin
          BufGetStr(bfgPKTLine);
          If Length(OutString)>0 Then deDecode; { Zeile prfen/decodieren }
        End;
        CloseMail; { es ist sicher, da diese Mail zu Ende ist }

        {$IFDEF Binkley}
        BnkCloseMail;
        {$ENDIF}

        Inc(stFileMsgCheck);
        Inc(stAllFMsgCheck);
      End Else Begin
        While (InFileEnd=feNo) And (ErrorAbort=eaOK) Do
          BufGetStr(bfgPKTLine);
      End;

     {$IFDEF Debug_BNK}
     BnkLog('mail closed'#13#10);
     {$ENDIF}

      Inc(stFileMsg);
      Inc(stAllFMsg);
      If stFileMsg Mod 10=0 Then UpdateDecodeScreen;
    End;

    UpdateDecodeScreen;
  END;

{***************************************************************************}

  PROCEDURE UnpackPKT;
  BEGIN
    Inpos:=SizeOf(TPktHdr);
    Move(InField^, DestField^, Inpos);
    DestPos:=Inpos;

    UnpackMSG(ptPKT);

    If FDestOpen Then Begin { 3*#0 am Dateiende erzeugen }
      Fillchar(DestField^[DestPos], 2, 0);
      Inc(Destpos, 2);
    End;
  END;

{***************************************************************************}

  PROCEDURE UnpackZConnect;
  { Abarbeitung eines ZCONNECT-Files }
  CONST hNone         = 0;
        hEMP          = 1;
        hBET          = 2;
        hLEN          = 4;
        hOK           = hEMP Or hBET Or hLEN;

        hzEMP         : String[4] = 'EMP:';
        hzBET         : String[4] = 'BET:';
        hzLEN         : String[4] = 'LEN:';

  VAR MailLen         : LongInt;
      Header, i       : Byte;
      OrgLenLinePos   : LongInt;
      OrgLenLineSize  : Byte;
  BEGIN
    While (InFileEnd=feNo) And (ErrorAbort=eaOK) Do Begin
      Fillchar(OutIDX, SizeOf(OutIDX), 0);

      ThisMsgHeadStart:=FDestFilePos+DestPos;
      Header:=hNone;
      Repeat
        BufGetStr(bfgText);
        If OutStringStart_CaseSensity(hzEMP) Then Begin
          i:=5;
          While ((OutString[i]=' ') Or (OutString[i]=#9))
            And (i<=Length(OutString)) Do Inc(i);
          Delete(OutString, 1, i-1);

          If Pos('/', OutString)=1 Then OutIDX.AreaStr:=Copy(OutString, 2, 255)
          Else OutIDX.AreaStr:='NETMAIL: '+OutString;

          Header:=Header Or hEMP;
        End Else If OutStringStart_CaseSensity(hzBET) Then Begin
          i:=5;
          While ((OutString[i]=' ') Or (OutString[i]=#9))
            And (i<=Length(OutString)) Do Inc(i);
          Delete(OutString, 1, i-1);

          OutIDX.SubjStr:=OutString;
          OutIDX.PartStr:=OutString;
          Header:=Header Or hBET;
        End Else If OutStringStart_CaseSensity(hzLEN) Then Begin
          OrgLenLinePos:=FDestMemPos;
          OrgLenLineSize:=Length(OutString);

          i:=5;
          While ((OutString[i]=' ') Or (OutString[i]=#9))
            And (i<=Length(OutString)) Do Inc(i);
          Delete(OutString, 1, i-1);

          MailLen:=Value(OutString);
          Header:=Header Or hLEN;
        End;
      Until (InFileEnd<>feNo) Or ( (Header=hOK) And (OutString='') );

      If InFileEnd=feNo Then Begin
        LenC:=MailLen;
        If ShallDecodeArea(OutIDX.AreaStr) Then Begin
          InitMail;

          While (InFileEnd=feNo) And (LenC>0) Do Begin
            BufGetStr(bfgText);
            If Length(OutString)>0 Then deDecode; { Zeile prfen/decodieren }
          End;

          CloseMail; { es ist sicher, da diese Mail zu Ende ist }
          If ThisMsgIsModified Then Begin
            OutString:='LEN: '+ST(FDestFilePos+DestPos-ThisMsgBodyStart,1);
            While Length(OutString)<OrgLenLineSize Do
              Insert('0', OutString, 6);

            xMemReplaceFile(FDest, OrgLenLinePos, OrgLenLinePos+OrgLenLineSize,
                                   OutString[1], Length(OutString),
                                   DestField^, DestPos);
            FDestFilePos:=xMemFilePos(FDest);
          End;

          Inc(stFileMsgCheck);
          Inc(stAllFMsgCheck);
        End Else Begin
          While (InFileEnd=feNo) And (LenC>0) Do
            BufGetStr(bfgText);
        End;
      End;

      Inc(stFileMsg);
      Inc(stAllFMsg);
      If stFileMsg Mod 10=0 Then UpdateDecodeScreen;
    End;

    UpdateDecodeScreen;
  END;

{***************************************************************************}

  PROCEDURE UnpackTxt;
  VAR i : Byte;
  BEGIN
    Fillchar(OutIDX, SizeOf(OutIDX), 0);
    OutIDX.AreaStr:='-';
    OutIDX.SubjStr:=StrTextfile;
    OutIDX.PartStr:=StrTextfile;

    ThisMsgHeadStart:=0;
    InitMail;
    While (InFileEnd=feNo) And (ErrorAbort=eaOK) Do Begin
      BufGetStr(bfgText);
      If Length(OutString)>0 Then
        If (Length(TextMark)>0)
         And (Copy(OutString,1,Length(TextMark))=TextMark) Then Begin
          CloseMail;

          i:=Length(TextMark)+1;
          While ((OutString[i]=' ') Or (OutString[i]=#9))
            And (i<=Length(OutString)) Do Inc(i);
          Delete(OutString, 1, i-1);
          OutIDX.SubjStr:=OutString;
          OutIDX.PartStr:=OutString;

          ThisMsgHeadStart:=FDestFilePos+DestPos;
          InitMail;
          Inc(stFileMsgCheck);
          Inc(stAllFMsgCheck);
          Inc(stFileMsg);
          Inc(stAllFMsg);
          If stFileMsg Mod 10=0 Then UpdateDecodeScreen;
        End Else deDecode;

    End;

    { bei reinem Textfile kann MsgData > MsgCheck sein! -> Anpassung: }
    CloseMail;
    If stFileMsgData>stFileMsg Then Begin
      Inc(stAllFMsg,      stFileMsgData-stFileMsg);
      Inc(stAllFMsgCheck, stFileMsgData-stFileMsg);
      stFileMsg:=stFileMsgData;
      stFileMsgCheck:=stFileMsgData;
    End;

    UpdateDecodeScreen;
  END;

{***************************************************************************}

var l: word;
BEGIN
  lfnOpenFile(FSource, DecodeList^.FromPath+DecodeList^.Name[FPos], ofRead);
  If Result=0 Then Begin
    FDestOpen:=False;

    Inc(stFileNumber);
    stFileName:=DecodeList^.Name[FPos];
    lfnShortenFileName(stFileName);
    stFileName:=stFileName+S(13-Length(stFileName));
    stFileSize:=FileSize(FSource);

    BlockRead(FSource, Infield^, BlockSize, Got);
    If (IOResult=0) And (Got>=5) Then Begin
      Insize:=Got;
      InfieldReadAll:=(Got<>BlockSize);
      DetectPKTType;

      Inpos:=0;
      DestPos:=0;
      InFileEnd:=feNo;

      Case PKTType Of
        ptUnknown   : stFileName:=stFileName+StrTextfile;
        ptPKT       : stFileName:=stFileName+'(Fido-PKT) ';
        ptMSG       : stFileName:=stFileName+'(Fido-MSG) ';
        ptZCONNECT  : stFileName:=stFileName+'(ZConnect) ';
      End;

      Inc(stAllFPrcd, Got);
      stFilePrcd:=Got;
      stFileMsg      :=0;
      stFileMsgCheck :=0;
      stFileMsgData  :=0;
      stFileDecode   :=0;

      UpDateDecodeScreen;

      ThisMsgModify:=ShallModifyArea('', PKTType);

      If (ThisMsgModify<>mmNo) Or
         ( (PKTType=ptPKT) Or (PKTType=ptMSG) And (BinkleyFilter) ) Then Begin
        FDestName.Name:=DecodeList^.Name[FPos];
        FDestName.Long:=(lfnUseLongNames<>lfnUNo) And
          (lfnDriveSupportsLFN(DecodeList^.FromPath[1]));

        l:=0;
        Repeat
          GetNextName(FDestName, dupRenameFile);
          inc(l);
        Until (Not lfnExistFile(DecodeList^.FromPath+FDestName.Name))
         or (l=0);

        if l=0 then result:=1
        else
          lfnOpenFile(FDest, DecodeList^.FromPath+FDestName.Name, ofCreate);

        If Result=0 Then Begin
          FDestOpen:=True;
          FDestError:=False;
          FDestFilePos:=0;

          xMemOpenFile(FDest, xcWrite, DestField^, DestPos);
          If Result<>0 Then FDestError:=True;
        End Else Begin
          If (LogLevel And logErrors<>0) Then
            WriteLogFile(TxtTmpCrt+DecodeList^.FromPath+FDestName.Name);
        End;
      End;

      If PKTType=ptPKT Then UnpackPKT
      Else If PKTType=ptMSG Then UnpackMSG(ptMSG)
      Else If PKTType=ptZConnect Then Begin
        UnpackZConnect;
        LogMailFileName:=DecodeList^.FromPath+DecodeList^.Name[FPos];
      End Else UnpackTxt;

      If FDestOpen Then Begin
        xMemCloseFile(FDest, DestField^, DestPos);
        If Result<>0 Then FDestError:=True;
        lfnCloseFile(FDest);

        If FDestError And (LogLevel And logErrors<>0) Then
          WriteLogFile(TxtTmpWrt);
      End;
    End;

    lfnCloseFile(FSource);
    If FDestOpen Then Begin
{$IFNDEF Debug_PKT}
      If FDestError Or (ErrorAbort<>eaOK) Then Begin
        lfnEraseFile(DecodeList^.FromPath+FDestName.Name);
      End Else Begin
        lfnEraseFile(DecodeList^.FromPath+DecodeList^.Name[FPos]);
        lfnRenameFile(DecodeList^.FromPath+FDestName.Name,
                      DecodeList^.FromPath+DecodeList^.Name[FPos]);
        If (Result<>0) And (LogLevel And logErrors<>0) Then
          WriteLogFile(TxtTmpRen);
      End;
{$ENDIF}
    End;
  End Else Begin
    If (LogLevel And logErrors<>0) Then
      WriteLogFile(TxtDenied1+DecodeList^.FromPath+DecodeList^.Name[FPos]+
        TxtDenied2);

    Dec(stAllFSize, stFileSize);
    Inc(stAllFSize, Got);
    UpDateDecodeScreen;
  End;
END;

{***************************************************************************}
{ Initalisierung }
{***************************************************************************}

PROCEDURE CloseDecode;
VAR i: Word;
BEGIN
  If DecodeList^.Counter>0 Then Begin
    OpenDecodeScreen;

    New(InField);
    New(DestField);

    OutIDX.Typ:=opNone;
    deGetMem;

    xMemOpenFile(DatFile, xcWrite, OutField^, OutPos);
    If Result<>0 Then ErrorAbort:=eaDatFileRead;
    xMemTruncFile(DatFile, DatFileSize, OutField^, OutPos);
    If Result<>0 Then ErrorAbort:=eaDatFileRead;

    i:=1;
    While (i<=DecodeList^.Counter) And (ErrorAbort=eaOK) Do Begin
      DecodePKT(i);
      Inc(i);
    End;

    CloseMail;

    deFreeMem;
    Dispose(DestField);
    Dispose(InField);

    xMemCloseFile(DatFile, OutField^, OutPos);
    If Result<>0 Then ErrorAbort:=eaDatFileWrite;

    CloseWindow;
  End;

  Dispose(Decodelist);
END;

PROCEDURE InitDecode;
BEGIN
  New(DecodeList);
  DecodeList^.FromPath:='';
  DecodeList^.Counter:=0;

  jobExec:=jobExec Or jobDecodeFiles;
END;

{***************************************************************************}
{ Verzeichnis einlesen }
{***************************************************************************}

PROCEDURE PreReadDir;
VAR SR                 : lfnSearchRec;
    Fl                 : File;
    FileList           : pFileList;
    n                  : Word;
    Buf, Buf2          : fnStr;

  PROCEDURE QuickSort(l,r: Word);
  VAR i,j: Word;
  BEGIN
    i:=l;
    j:=r;
    Buf:=FileList^.Name[(l+r) Div 2];
    Repeat
      While Filelist^.Name[i]<Buf Do Inc(i);
      While Filelist^.Name[j]>Buf Do Dec(j);

      If i<=j Then Begin
        Buf2:=Filelist^.Name[i];
        Filelist^.Name[i]:=Filelist^.Name[j];
        Filelist^.Name[j]:=Buf2;

        Inc(i);
        Dec(j);
      End;
    Until i>j;
    If l<j Then QuickSort(l,j);
    If i<r Then QuickSort(i,r);
  END;

{$IFDEF German}
CONST Txt1 = 'lese Verzeichnis...';
      Txt2 = 'Fehler: ';
      Txt3 = 'fertig, entpacken Sie nun Dateien in dieses Verzeichnis';
      Txt4 = 'Fehler beim Erstellen der temporren Datei';
{$ELSE}
CONST Txt1 = 'reading directory...';
      Txt2 = 'error: ';
      Txt3 = 'done, now extract files to this directory';
      Txt4 = 'error writing temporary file';
{$ENDIF}
BEGIN
  CheckOldFilelist;

  Write(Txt1);

  New(Filelist);
  Fillchar(Filelist^, Sizeof(Filelist^), 0);
  Filelist^.Counter:=0;
  Filelist^.FromPath:=CmdFile;
  Delete(Filelist^.FromPath, 1, Pos('=',Filelist^.FromPath));
  If Filelist^.FromPath='' Then Filelist^.FromPath:='*.*';
  Filelist^.FromPath:=lfnFExpand(Filelist^.FromPath);

  If Not lfnExistPath(fnDir(FileList^.FromPath)) Then Begin
    WriteLn;
    WriteLn(Txt2+fnDir(FileList^.FromPath)+notexist);
    JobExec:=JobExec Or JobTerminate;
  End Else Begin
    lfnFindFirst(Filelist^.FromPath, AnyFile, SR);
    While DosError=0 Do Begin
      If (SR.Attr And (Directory Or VolumeID)=0)
       And (Filelist^.Counter<Maxlist) Then Begin
        Inc(Filelist^.Counter);
        Filelist^.Name[Filelist^.Counter]:=SR.Name.Name;
      End;

      lfnFindNext(SR);
    End;
    lfnFindClose(SR);

    If FileList^.Counter>0 Then QuickSort(1, Filelist^.Counter);

    lfnOpenFile(Fl, DBPath+PreDirName, ofCreate);
    If Result=0 Then Begin
      BlockWrite(Fl, Filelist^, SizeOf(TFLHeader)
        +FileList^.Counter*SizeOf(fnStr));
      GetError;
      lfnCloseFile(Fl);
      WriteLn(Txt3);
    End Else Begin
      WriteLn(Txt4);
      JobExec:=JobExec Or JobTerminate;
    End;
  End;

  Dispose(Filelist);
END;

{***************************************************************************}

PROCEDURE CheckDir;
VAR SR                 : lfnSearchRec;
    Fl                 : File;
    FileList           : pFileList;
{$IFDEF OS2}
    n                  : LongInt;
{$ELSE}
    n                  : Word;
{$ENDIF}
    FromPath           : PathStr;
    ErrorStr           : S80;

  FUNCTION BinSearch(i,j: Word): Boolean;
  VAR n: Word;
  BEGIN
    If j<i Then BinSearch:=False
    Else Begin
      n:=(i+j) Div 2;
      If SR.Name.Name>Filelist^.Name[n] Then BinSearch:=BinSearch(n+1,j)
      Else If SR.Name.Name<Filelist^.Name[n] Then BinSearch:=BinSearch(i,n-1)
      Else BinSearch:=True;
    End;
  END;

{$IFDEF German}
CONST Txt1 = 'suche nach neuen Dateien...';
      Txt2 = ' fehlerhaft!';
      Txt3 = 'es wurde kein Verzeichnis voreingelesen';
{$ELSE}
CONST Txt1 = 'searching for new files...';
      Txt2 = ' damaged!';
      Txt3 = 'no directory prescaned';
{$ENDIF}
BEGIN
  WriteLn(Txt1);
  ErrorStr:='';

  InitDecode;

  lfnOpenFile(Fl, DBPath+PreDirName, ofRead);
  If Result=0 Then Begin
    New(FileList);
    BlockRead(Fl, Filelist^, SizeOf(FileList^), n);
    If (n=SizeOf(TFLHeader)+FileList^.Counter*SizeOf(fnStr)) Then Begin
      DecodeList^.Frompath:=fnFull(fnDir(Filelist^.Frompath));

      lfnFindFirst(Filelist^.Frompath, AnyFile, SR);
      While (DosError=0) And (ErrorAbort=eaOK) Do Begin
        If (SR.Attr And (Directory Or VolumeID)=0)
         And (Not BinSearch(1, Filelist^.Counter)) Then Begin
           If DecodeList^.Counter<MaxList Then Begin
             Inc(DecodeList^.Counter);
             DecodeList^.Name[DecodeList^.Counter]:=SR.Name.Name;
           End;

           Inc(stAllFNumber);
           Inc(stAllFSize, SR.Size);
         End;

        lfnFindNext(SR);
      End;
      lfnFindClose(SR);

    End Else ErrorStr:=PreDirName+Txt2;
    Dispose(Filelist);
    lfnCloseFile(Fl);
  End Else ErrorStr:=Txt3;
  lfnEraseFile(DBPath+PreDirName);

  If ErrorStr<>'' Then Begin
    WriteLn(ErrorStr);
    JobExec:=JobExec Or JobTerminate;
  End;
END;

{***************************************************************************}
{ Dateien direkt entpacken }
{***************************************************************************}

PROCEDURE UnpackFiles;
VAR SR : lfnSearchRec;
    Path : String;
BEGIN
  Path:=fnFull(fnDir(lfnFExpand(CmdFile)));
  If Not lfnExistPath(Path) Then Begin
    WriteLn;
    WriteLn(Path+notexist);
    JobExec:=JobExec Or JobTerminate;
  End Else Begin
    InitDecode;

    DecodeList^.FromPath:=Path;
    lfnFindFirst(CmdFile, AnyFile, SR);
    { hier initalisiert W95 die Laufwerke! }

    While (DosError=0) And (ErrorAbort=eaOK) Do Begin
      If SR.Attr And (Directory Or VolumeID)=0 Then Begin
        If DecodeList^.Counter<MaxList Then Begin
          Inc(DecodeList^.Counter);
          DecodeList^.Name[DecodeList^.Counter]:=SR.Name.Name;
        End;

        Inc(stAllFNumber);
        Inc(stAllFSize, SR.Size);
      End;

      lfnFindNext(SR);
    End;
    lfnFindClose(SR);
  End;
END;

{***************************************************************************}
{ Hilfetext }
{***************************************************************************}

PROCEDURE DisplayHelp;
BEGIN
{$IFDEF German}
  WriteLn;
  WriteLn('Funktion: dekodiert mit UUENCODE, XXENCODE, BASE64 oder BINHEX kodierte Dateien');
  WriteLn('          aus Textdateien, Fido-PKT-/MSG- oder ZConnect-Mailpaketen');
  WriteLn('Aufruf: PKTXCODE [Parameter]');
  WriteLn('Gltige Parameter sind:');
  WriteLn('  /T[EST]                zum Testen der INI-Datei');
  WriteLn('  Dateiname              zum direkten Dekodieren (Jokerzeichen sind erlaubt)');
  WriteLn('  /R[EADDIR]=Dateiname   zum Voreinlesen eines Verzeichnisses vor dem Aufruf');
  WriteLn('                         eines Entpackers (z.B. /R=C:\PACK\*.PKT)');
  WriteLn('                         READDIR-Aufruf');
  WriteLn('  /C[HECKDIR]            zum Dekodieren aller neuen Dateien seit dem letzten');
  WriteLn('  /E[XTRACT]=Pfad        alle dekodierten Dateien in Verzeichnis "Pfad"');
  WriteLn('                         schreiben (berschreibt Einstellung in INI-Datei)');
  WriteLn('  /X                     einzeln: Datenbank nach vollst. Dateien durchsuchen');
  WriteLn('                         sonst: dekodierte Dateien in Datenbank belassen');
  WriteLn('  /L[IST][Dateiname]     listet Datenbank [in Datei]');
  WriteLn('  /M[ANUELL]             zum manuellen Bearbeiten der Datenbank');
  WriteLn('  /V[ERIFY]              zum berprfen der Datenbank');
{$ELSE}
  WriteLn;
  Writeln('Function: decodes with UUENCODE, XXENCODE, BASE64 or BINHEX encoded files out');
  WriteLn('          of text files, Fido-PKT-/MSG- or ZConnect files');
  WriteLn('Usage: PKTXCODE [parameters]');
  WriteLn('Valid commands are:');
  WriteLn('  /T[EST]                to test INI file');
  WriteLn('  filename               to decode (wildcars may be used)');
  WriteLn('  /R[EADDIR]=filename    to scan a directory before calling an unpacker');
  WriteLn('                         (e.g. /R=C:\PACK\*.PKT)');
  WriteLn('  /C[HECKDIR]            to decode all new files since last READDIR-call');
  WriteLn('  /E[XTRACT]=path        write all decoded files in path "path" (overrides');
  WriteLn('                         setting in INI file');
  Writeln('  /X                     single: scan database for complete files');
  WriteLn('                         otherwise: decoded files remain in database');
  WriteLn('  /L[IST][filename]      creates filelist of database [into file]');
  WriteLn('  /M[ANUAL]              to modify database manually');
  WriteLn('  /V[ERIFY]              to verify database');
{$ENDIF}
END;

{***************************************************************************}
{ Tor ! }
{***************************************************************************}

VAR e : Byte;
BEGIN
{$IFDEF German}
  WriteLn(verName + ' - ' + verYear +'-'+verMonth+'-'+verDay);
{$ELSE}
  WriteLn(verName + ' - ' + verMonth+'-'+verDay  +'-'+verYear);
{$ENDIF}
  WriteLn('(c) 1996-98 Ulrich Mueller, email: ulrich.mueller@bigfoot.de');
  Writeln('PktXCode comes with ABSOLUTELY NO WARRANTY. This is free software, and you are');
  WriteLn('welcome to redistribute it under certain conditions; for details read the GNU');
  WriteLn('GENERAL PUBLIC LICENSE in file COPYING.');

  If MaxAvail<HeapRequired Then Begin
{$IFDEF German}
    WriteLn(HeapRequired-MaxAvail,' Byte zu wenig Hauptspeicher!');
{$ELSE}
    WriteLn(HeapRequired-MaxAvail,' bytes conventional memory missing!');
{$ENDIF}
    Halt(1);
  End;

  If (ioGetParamCount<>1) And (ioGetParamCount<>2) Then DisplayHelp
  Else Begin
    {$IFNDEF OS2}
    InitWriteXY;
    {$ENDIF}

    Randomize;
    stProcessTime:=GetTimeReal;

    AnalyseParam;
    e:=0;
    While (e<16) And (ErrorAbort=eaOK) And (JobExec And JobTerminate=0) Do Begin
      If JobExec And (1 Shl e)<>0 Then
        Case Word (1 Shl e) Of
          jobLoadINIFile      : LoadIniFile;
          jobPrereadDir       : PreReadDir;
          jobCheckDir         : CheckDir;
          jobUnpackFiles      : Unpackfiles;
          jobXMemInit         : XMemInit;
          jobOpenDataBase     : OpenDatabase;
          jobVerifyDataBase   : VerifyDataBase;
          jobTestINIFile      : TestINIFile;
          jobListDataBase     : ListDataBase;
          jobDecodeFiles      : CloseDecode;
          jobBuildDataBase    : BuildDataBase;
          jobExtractDatabase  : ExtractDatabase;
          jobExtractManual    : ExtractDatabaseManuel;
          jobDisplayHelp      : DisplayHelp;
        End;

      Inc(e);
    End;

    ReleaseMemory;
    {$IFDEF Binkley}
    If BinkleyFilter Then BnkCheckDatabase;
    {$ENDIF}
    CloseDatabase;
    CloseLogFile;
    XMemClose;

    If ErrorAbort<>eaOK Then Begin
      If ErrorAbort<>eaHalt Then Begin
        WriteLn;
        WriteLn(ErrorText);
      End;
    End;
  End;

  Halt(ErrorAbort);
END.

{***************************************************************************}
{ was soll denn noch kommen ? }
{***************************************************************************}

