{ PktXCode - decodes with UUENCODE, XXENCODE, BASE64 or BINHEX encoded files
             out of text files, Fido-PKT-/MSG- or ZConnect files

  Copyright (C) 1996-98 Ulrich Mueller, email: ulrich.mueller@bigfoot.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


  This source code is compatible with:
  - Borland Pascal 7.0 (DOS)
  - Virtual Pascal 1.1 (OS/2)

}

Program Install;

{ 15.11.96 Fehler in Createmsg behoben
  28.11.96 Fehler mit Rename/OS2 behoben
  31.12.96 Fehler in Logmeldung: Interzonenmails behoben
}

{$M 16384, 54000, 54000}  { = INI-File + SCR }
{$I SETTINGS.INI}

{$IFDEF OS2}
{$LINKER
NAME PktXCode
STUB "C:\BP\EXE\INSTALL.EXE"
}
Uses CRT_OS2,
{$ELSE}
Uses CRT    ,
{$ENDIF}
              DOS, PKTX_KEY, PKTX_SCR, PKTX_IO, PKTX_LFN, INST_HDD, INST_INI;

{$IFDEF German}
CONST Txt00 = 'Kopiere Dateien';
      Txt01 = 'Verzeichnis selbst eingeben';
      Txt02 = 'Verzeichnis auswhlen, in dem sich Crosspoint befindet:';
      Txt03 = 'Verzeichnis auswhlen, in dem sich das alte PKTXCODE befindet:';
      Txt04 = '(Tasten: Cursortasten=whlen, Return=besttigen, ESC=abbrechen)';
      Txt05 = 'Verzeichnis eingeben, in dem das alte PKTXCODE installiert ist:';
      Txt06 = 'Verzeichnis eingeben, in dem Crosspoint installiert ist:';
      Txt07 = 'Verzeichnis eingeben, in das PKTXCODE installiert werden soll:';
      Txt08 = 'Verzeichnis eingeben, worin dekodierte Dateien abgelegt werden sollen:';
      Txt09 = 'Dateien';
      Txt10 = 'Bitte whlen Sie:';
      Txt11 = '(1) PKTXCODE neu installieren';
      Txt12 = '(2) PKTXCODE in Crosspoint installieren';
      Txt13 = '(3) vorhandene Version von PKTXCODE updaten';
      Txt14 = '(4) Programmende';
      Txt15 = 'Installationsprogramm fr ';
      Txt16 = 'Fehler beim Kopieren der Dateien';
      Txt17 = 'Installation beendet';
      Txt18 = 'Fehler beim Schreiben der INI-Datei';
      Txt19 = 'Fehler beim Anpassen der XP-Konfiguration';
      Txt20 = 'Abbruch durch Benutzer';
      Txt21 = 'Tsch!';
      Txt22 = 'interner Fehler #';
      Txt23 = 'Die neue Konfiguration wird berprft...';
      Txt24 = 'Fehler: Installationsdateien sind unvollstndig';
      Txt25 = 'Suche alte Version:';

      TxtHelp1 = 'Mgliche Parameter:';
      TxtHelp2 = '  /X - unterdrckt automatische Dursuchung aller Laufwerke nach alter';
      TxtHelp3 = '       alter Programmversion';
      TxtAutor = 'Ulrich Mller';
{$ELSE}
CONST Txt00 = 'copying files';
      Txt01 = 'enter directory yourself';
      Txt02 = 'select the directory containing Crosspoint:';
      Txt03 = 'select the directory containing the old version of PKTXCODE:';
      Txt04 = '(keys: cursor keys=select, return=confirm, ESC=abort)';
      Txt05 = 'enter the directory containing the old version of PKTXCODE:';
      Txt06 = 'enter the directory Crosspoint is installed in:';
      Txt07 = 'enter the directory where install PKTXCODE:';
      Txt08 = 'enter the directory decoded files shall be written in:';
      Txt09 = 'Files';
      Txt10 = 'Please select:';
      Txt11 = '(1) new installation of PKTXCODE';
      Txt12 = '(2) install PKTXCODE in Crosspoint';
      Txt13 = '(3) update existing version of PKTXCODE';
      Txt14 = '(4) quit';
      Txt15 = 'Installation program for ';
      Txt16 = 'error copying files';
      Txt17 = 'installation finished';
      Txt18 = 'error writing INI file';
      Txt19 = 'error adapting the XP configuration';
      Txt20 = 'aborted by user';
      Txt21 = 'Bye!';
      Txt22 = 'internal error #';
      Txt23 = 'Now verifying the new configuration...';
      Txt24 = 'error: installation files are incomplete';
      Txt25 = 'Searching for old version:';

      TxtHelp1 = 'possible parameters:';
      TxtHelp2 = '  /X - avoids automatical scan of all drives for older programm';
      TxtHelp3 = '       version';
      TxtAutor = 'Ulrich Mueller';
{$ENDIF}

{***************************************************************************}
{ Titelbild darstellen }
{***************************************************************************}

PROCEDURE ShowTitle;
CONST xTitle = 19;
      yTitle =  9;

      dBlink = 100;
      dIntro = 400;
      dNext  = 500;

  PROCEDURE WriteI1(c: Byte);
  BEGIN
    WriteXY((79-Length(TxtAutor)) Div 2,12,c,TxtAutor);
  END;

  PROCEDURE WriteI2(c: Byte);
  CONST Txt='proudly presents';
  BEGIN
    WriteXY((79-Length(Txt)) Div 2,12,c,Txt);
  END;

  PROCEDURE WriteTitle(c: Byte);
  BEGIN
    WriteXY( xTitle+1, yTitle  ,c,'PPP  K  K TTT X   X  CC   OO  DDD   EEE');
    WriteXY( xTitle+1, yTitle+1,c,'P  P K K   T   X X  C  C O  O D  D  E');
    WriteXY( xTitle+1, yTitle+2,c,'PPP  KK    T    X   C    O  O D   D EE');
    WriteXY( xTitle+1, yTitle+3,c,'P    K K   T   X X  C  C O  O D  D  E');
    WriteXY( xTitle+1, yTitle+4,c,'P    K  K  T  X   X  CC   OO  DDD   EEE');
  END;

  PROCEDURE WriteT1(c: Byte);
  BEGIN
    WriteXY( xTitle, yTitle-1, c, 'this');
  END;

  PROCEDURE WriteT2(c: Byte);
  BEGIN
    WriteXY( xTitle+16, yTitle-1, c, 'program');
  END;

  PROCEDURE WriteT3(c: Byte);
  BEGIN
    WriteXY( xTitle+33, yTitle-1, c, 'features');
  END;

  PROCEDURE ShowFeatures;
  CONST fn = 10;
  VAR i : Byte;

    FUNCTION fText: String;
    BEGIN
      Case i Of
        1: fText:='UUDECODE';
        2: fText:='XXDECODE';
        3: fText:='BASE64-DECODE';
        4: fText:='BINHEX-DECODE';
        5: fText:='SPLITTED & UNSORTED MESSAGES';
        6: fText:='DATABASE FOR INCOMPLETE FILES';
        7: fText:='FAST ASSEMBLER DECODING';
        8: fText:='EASY PROGRAM UPDATE';
        9: fText:='AUTOMATIC CROSSPOINT INSTALLATION';
       10: fText:='CRAZY INSTALLATION PROGRAM';
      End;
    END;

  BEGIN
    For i:=1 To fn Do Begin
      sDelay(dNext);
      WriteXY(39-(Length(fText) Div 2), yTitle+7, fWhite, fText);
      sDelay(dBlink);
      WriteXY(39-(Length(fText) Div 2), yTitle+7, fLightGray, fText);
      sDelay(15*Length(fText));
      WriteXY(39-(Length(fText) Div 2), yTitle+7, fDarkGray, fText);
      sDelay(10*Length(fText));
      WriteXY(0,                        yTitle+7, fLightGray, S(80));
    End;
    sDelay(dNext);
  END;

BEGIN
  OpenWindow(80,25,fLightGray+bBlack, 2);
  if not hdseekdone then WriteXY(0,23,fLightGray+bBlack,Txt25);

{  sDelay(dNext);
  WriteI1(fWhite);
  sDelay(dIntro);
  WriteI1(fBlack);
  sDelay(dIntro);

  WriteI2(fWhite);
  sDelay(dIntro);
  WriteI2(fBlack);
  sDelay(dIntro);}

  sDelay(dNext);
  WriteTitle(fLightRed);

  sDelay(dNext*2);
  WriteT1(fWhite);
  sDelay(dBlink);
  WriteT1(fLightGray);

  sDelay(dNext);
  WriteT2(fWhite);
  sDelay(dBlink);
  WriteT2(fLightGray);

  sDelay(dNext);
  WriteT3(fWhite);
  sDelay(dBlink);
  WriteT3(fLightGray);

  ShowFeatures;
  ClearC(0,0,79,23,fLightGray);
  ErrorAbort:=eaOK;
END;

{***************************************************************************}

FUNCTION GetPath(Desc, Vorschlag: String): String;
CONST x0 = 2;
      y0 = 4;
      maxl = 70;
VAR i, xcOld, ycOld : Byte;
    c               : tKey;
    Out             : String;
BEGIN
  OpenWindow(76,8,fBlack+bLightGray,0);
  WriteXY(2,2,fBlack+bLightGray, Desc);

  If Length(Vorschlag)>MaxL Then Vorschlag[0]:=Chr(MaxL);
  i:=Length(Vorschlag)+1;
  GetCursorPos(xcOld, ycOld);
  ShowCursor;
  Repeat
    SetCursorPos(x0+i-1, y0);
    WriteXY(x0, y0, fYellow+bBlue, Vorschlag+S(maxL+1-Length(Vorschlag)));

    Out:=fnFull(lfnFExpand(Vorschlag));
    If Not lfnDriveSupportsLFN(Out[1]) Then lfnShortenPathName(Out);
    Out:='-> '+Out;

    If Length(Out)>MaxL Then Out[0]:=Chr(MaxL);
    WriteXY(x0, y0+1, fBlack+bLightGray, Out+S(maxL+1-Length(Out)));

    sGetKey(c);
    If c.Scan=kbBack Then
      If i>1 Then Begin
        Delete(Vorschlag, i-1, 1);
        Dec(i);
      End Else
    Else If c.Scan=kbDel Then
      If i<=Length(Vorschlag) Then
        Delete(Vorschlag, i, 1)
      Else
    Else If c.Scan=kbLeft Then
      If i>1 Then Dec(i)
      Else
    Else If c.Scan=kbRight Then
      If i<=Length(Vorschlag) Then Inc(i)
      Else
    Else If c.Scan=kbHome Then i:=1
    Else If c.Scan=kbEnd Then i:=Length(Vorschlag)+1
    Else If (c.Char>=#32) And (Length(Vorschlag)<MaxL) Then Begin
      Insert(c.Char, Vorschlag, i);
      Inc(i);
    End;
  Until (c.Scan=kbEnter) Or (c.Scan=kbESC);
  HideCursor;
  SetCursorPos(xcOld, ycOld);
  CloseWindow;

  If c.Scan=kbESC Then GetPath:=''
  Else Begin
    Out:=fnFull(lfnFExpand(Vorschlag));
    If Not lfnDriveSupportsLFN(Out[1]) Then lfnShortenPathName(Out);
    GetPath:=Out;
  End;
END;

{***************************************************************************}

PROCEDURE KopiereDateien;
var i:byte;

 Procedure fcopy(Name: String);
 var f1, f2              : file;
     buffer              : array[1..2048] of char;
     toread              : word;
     error               : boolean;
     size, time          : LongInt;
 begin
   error:=false;

   lfnOpenFile(F1, OwnPath+Name, ofRead);
   if result<>0 then error:=true;

   lfnOpenFile(F2, InstPath+Name, ofCreate);
   if result<>0 then error:=true;

   if not error then begin
     size:=filesize(f1);
     while (size>0) and (not error) do begin
       if size>sizeof(buffer) then toread:=sizeof(buffer)
       else toread:=size;
       dec(size, toread);

       BlockRead(f1, Buffer, toread);
       if ioresult<>0 then error:=true;
       BlockWrite(f2, Buffer, toread);
       if ioresult<>0 then error:=true;
     end;

     if not error then begin
       getftime(f1, time);
       geterror;
       setftime(f2, time);
       geterror;
     end;
   end;
   lfnCloseFile(f1);
   lfnCloseFile(f2);

   if error then errorabort:=eaInstFileCopy;
 end;

BEGIN
  OpenWaitWindow(Txt00);

  If lfnExistCreatePath(InstPath) Then Begin
    fcopy('PKTXCODE.EXE');
    fcopy('PKTXCODE.DOC');
    fcopy('COPYING');
  End Else ErrorAbort:=eaInstFileCopy;

  CloseWindow;
END;

{***************************************************************************}

CONST PKTX = 0;
      XP   = 1;

PROCEDURE SelectPath(Mode: Byte);
VAR i, Start, Old : Byte;
    c             : tKey;
    Path          : PathStr;

  PROCEDURE ShowScreen;
  VAR y   : Byte;
      Txt : S80;
  BEGIN
    If i<Start Then Start:=i
    Else If i>Start+9 Then Start:=i-9;

    For y:=0 To 9 Do Begin
      If Start+y=1 Then Txt:=Txt01
      Else If Mode=PKTX Then Txt:=PKTXPathA[y+Start-1]
           Else              Txt:=XPPathA[y+Start-1];
      If Length(Txt)>69 Then Txt[0]:=#69;
      Txt:=Txt+S(69-Length(Txt));

      If y+Start=i Then Txt:='-> '+Txt
      Else Txt:='   '+Txt;

      WriteXY(2,5+y,fYellow+bBlue, Txt);
    End;
  END;

BEGIN
  InstPath:='';

  OpenWindow(76,17,fBlack+bLightGray,0);

  If Mode=XP Then
    WriteXY(10,2,fBlack+bLightGray,Txt02)
  Else
    WriteXY( 7,2,fBlack+bLightGray,Txt03);
  WriteXY(7,3,fBlack+bLightGray,Txt04);

  i:=1;
  Start:=1;
  Repeat
    Old:=255; { Screenupdate }
    Repeat
      Repeat
        If PKTXPathC+XPPathC<>Old Then Begin
          Old:=PKTXPathC+XPPathC;
          ShowScreen;
        End;
        NextHDDSeek;
      Until KeyPressed;
      sGetKey(c)
    Until (c.Scan=kbup) Or (c.Scan=kbdown) Or (c.Scan=kbHome) Or
     (c.Scan=kbEnd) Or (c.Scan=kbEnter) Or (c.Scan=kbESC);
    Case c.Scan of
      kbup      : If i>1 Then Dec(i);
      kbdown    : If (Mode=PKTX) And (i<PKTXPathC+1) Then Inc(i)
                  Else If (Mode=XP) And (i<XPPathC+1) Then Inc(i);
      kbHome    : i:=1;
      kbEnd     : If (Mode=PKTX) Then i:=PKTXPathC+1
                  Else i:=XPPathC+1;
    End;
  Until (c.Scan=kbEnter) Or (c.Scan=kbEsc);
  CloseWindow;

  If c.Scan=kbEnter Then Begin
    If Mode=PKTX Then
      If i=1 Then Path:=GetPath(Txt05, '')
      Else Path:=PKTXPathA[i-1]
    Else
      If i=1 Then Path:=GetPath(Txt06, '')
      Else Path:=XPPathA[i-1];

    If Path<>'' Then InstPath:=Path;
  End;
END;

{***************************************************************************}

FUNCTION AskSeekok: Boolean;
CONST c = fWhite+bBlue;
VAR Key : tKey;
BEGIN
{$IFDEF German}
  OpenWindow(39,7,c,wWindow1);
  WriteXY( 2, 2, c, 'Sollen die lokalen Laufwerke nach');
  WriteXY( 2, 3, c, 'einer alten Version und/oder');
  WriteXY( 2, 4, c, 'Crosspoint durchsucht werden? (J/N)');
{$ELSE}
  OpenWindow(46,5,c,wWindow1);
  WriteXY( 2, 2, c, 'Scan local drives for older version? (Y/N)');
{$ENDIF}

  Repeat
    GetKey(Key);
  Until Key.UpChar In ['J','Y','N'];

  CloseWindow;
  AskSeekOk:=(Key.UpChar<>'N');
END;

{***************************************************************************}

PROCEDURE NewInstall;
BEGIN
  InstPath:=GetPath(Txt07, '');
  If InstPath='' Then Exit;

  ExtPath:=GetPath(Txt08, InstPath+Txt09);
  If ExtPath='' Then Exit;

  LogPath:=InstPath;
  LogSumPath:=InstPath;

  KopiereDateien;
  If ErrorAbort=0 Then Begin
    SaveINIFile;
  End;
END;

{***************************************************************************}

PROCEDURE XPInstall;
VAR Key: tKey;
BEGIN
  SelectPath(XP);
  If InstPath='' Then Exit;

  KopiereDateien;
  If ErrorAbort<>0 Then Exit;

  SaveINIFile; { krzt InstName auf Olddos }

{$IFDEF German}
  OpenWindow(62,9,fWhite+bBlue,wWindow1);
  WriteXY(2,2,fWhite+bBlue,'Das Installationsprogramm kann jetzt Ihre XP-Konfiguration');
  WriteXY(2,3,fWhite+bBlue,'automatisch aktualisieren. Sie knnen diesen Schritt aber');
  WriteXY(2,4,fWhite+bBlue,'auch selbst vornehmen, so wie es in der Dokumentation');
  WriteXY(2,5,fWhite+bBlue,'beschrieben ist.');
  WriteXY(2,6,fWhite+bBlue,'Wnschen Sie eine automatische Installation (J/N) ?');
{$ELSE}
  OpenWindow(51,8,fWhite+bBlue,wWindow1);
  WriteXY(2,2,fWhite+bBlue,'The installation program can now actualize your');
  WriteXY(2,3,fWhite+bBlue,'XP-configuration. You can also carry out this step');
  WriteXY(2,4,fWhite+bBlue,'on your own as mentioned in the documentation.');
  WriteXY(2,5,fWhite+bBlue,'Do you wish an automatic installation (Y/N) ?');
{$ENDIF}
  Repeat
    GetKey(Key);
  Until Key.UpChar In ['J','Y','N'];
  CloseWindow;

  If Key.UpChar<>'N' Then XPEinbindung;
END;

{***************************************************************************}

PROCEDURE InstallUpdate;
BEGIN
  SelectPath(PKTX);
  If InstPath='' Then Exit;

  LoadIniFile;
  If ErrorAbort<>0 Then Exit;
  KopiereDateien;
  If ErrorAbort<>0 Then Exit;
  SaveINIFile;
END;

{***************************************************************************}

PROCEDURE MainMenu;
VAR c: tKey;
BEGIN
  OpenWindow(47,9,fBlack+bLightGray,0);
  WriteXY(2,2,fBlack+bLightGray,Txt10);
  WriteXY(2,3,fBlack+bLightGray,Txt11);
  WriteXY(2,4,fBlack+bLightGray,Txt12);
  WriteXY(2,5,fBlack+bLightGray,Txt13);
  WriteXY(2,6,fBlack+bLightGray,Txt14);

  Repeat
    While KeyPressed Do
      sGetKey(c);

    Repeat
      sGetKey(c)
    Until (C.Char In ['1'..'4']) Or (C.Scan=kbESC);
    If c.Char='1' Then NewInstall
    Else If c.Char='2' Then XPInstall
    Else If c.Char='3' Then InstallUpdate
  Until (c.Char='4') Or (c.Scan=kbESC) Or (ErrorAbort<>0);
  CloseWindow;
END;

{***************************************************************************}

FUNCTION FilesOK: Boolean;
BEGIN
  FilesOK:=lfnExistFile(OwnPath+'PKTXCODE.EXE')
       And lfnExistFile(OwnPath+'PKTXCODE.DOC')
       And lfnExistFile(OwnPath+'PKTXCODE.INI')
       And lfnExistFile(OwnPath+'COPYING')
END;

{***************************************************************************}

BEGIN
  WriteLn(Txt15+verName +' - '
   {$IFDEF German} + verYear +'-'+verMonth+'-'+verDay
   {$ELSE}         + verMonth+'-'+verDay  +'-'+verYear {$ENDIF} );
  WriteLn('(c) 1996-98 Ulrich Mueller, email: ulrich.mueller@bigfoot.de');
  Writeln('PktXCode comes with ABSOLUTELY NO WARRANTY. This is free software, and you are');
  WriteLn('welcome to redistribute it under certain conditions; for details read the GNU');
  WriteLn('GENERAL PUBLIC LICENSE in file COPYING.');
  Writeln;

  InitHDDSeek;
  If ParamCount<>0 Then Begin
    If (ParamCount=1) And (UpcaseStr(ParamStr(1))='/X') Then HDSeekDone:=True
    Else Begin
      WriteLn;
      WriteLn(TxtHelp1);
      WriteLn(TxtHelp2);
      WriteLn(TxtHelp3);

      Halt(0);
    End;
  End;
  If Not HdSeekDone Then
    If Not AskSeekOK Then HDSeekDone:=True;

  If FilesOK Then Begin
{$IFNDEF OS2}
    InitWriteXY;
{$ENDIF}

    ShowTitle;
    MainMenu;

    CloseHDDSeek;
    CloseWindow;

    ReleaseMemory;
    Case ErrorAbort Of
      eaInstFileCopy     : WriteLn(Txt16);
      eaInstReady        : WriteLn(Txt17);
      eaInstWriteINIFile : WriteLn(Txt18);
      eaInstEditXP       : WriteLn(Txt19);
      eaUserBreak        : WriteLn(Txt20);
    Else If ErrorAbort=eaOK Then WriteLn(Txt21)
    Else WriteLn(Txt22,ErrorAbort);
    End;

    If ErrorAbort=eaInstReady Then Begin
      CheckOldDB;
{      CreateRegMSG;}

      WriteLn(Txt23);
      WriteLn;
      SwapVectors;
      Exec(InstPath+'PKTXCODE.EXE', '/T');
      SwapVectors;
    End;
  End Else Begin
    WriteLn(Txt24);
  End;
END.
